﻿
Module Module1

    Structure TRIGGER_CONDITION
        Dim channelA As Integer
        Dim channelB As Integer
        Dim channelC As Integer
        Dim channelD As Integer
        Dim external As Integer
        Dim aux As Integer
        Dim pulseWidthQualifier As Integer
    End Structure


    Declare Function ps4000OpenUnit Lib "ps4000.dll" (ByRef handle As Integer) As Integer
    Declare Sub ps4000CloseUnit Lib "ps4000.dll" (ByVal handle As Integer)

    Declare Function ps4000GetUnitInfo Lib "ps4000.dll" (ByVal handle As Integer, ByVal str As String, ByVal lth As Integer, ByRef requiredSize As Integer, ByVal info As Integer) As Integer

    Declare Function ps4000SetChannel Lib "ps4000.dll" (ByVal handle As Integer, ByVal channel As Integer, ByVal enabled As Short, ByVal dc As Short, ByVal range As Integer) As Integer
    Declare Function ps4000GetTimebase Lib "ps4000.dll" (ByVal handle As Integer, ByVal timebase As UInteger, ByVal noSamples As Integer, ByRef timeInterval As Integer, ByVal oversample As Short, ByRef maxSamples As Integer, ByVal segment As UInteger) As Integer
    Declare Function ps4000SetDataBuffer Lib "ps4000.dll" (ByVal handle As Integer, ByVal channel As Integer, ByRef buffer As Short, ByVal length As Integer) As Integer
    Declare Function ps4000GetValues Lib "ps4000.dll" (ByVal handle As Integer, ByVal startIndex As UInteger, ByRef numSamples As UInteger, ByVal downSampleRatio As UInteger, ByVal downsampleRatioMode As Short, ByVal segmentIndex As UShort, ByRef overflow As Short) As Integer
    Declare Function ps4000Stop Lib "ps4000.dll" (ByVal handle As Integer) As Integer

    Declare Function ps4000RunStreaming Lib "ps4000.dll" (ByVal handle As Integer, ByRef sampleInterval As UInteger, ByVal sampleIntervalTimeUnits As Integer, ByVal maxPreTriggerSamples As UInteger, ByVal maxPostPreTriggerSamples As UInteger, ByVal autoStop As Short, ByVal downSampleRatio As UInteger, ByVal overviewBufferSize As UInteger) As Integer

    Declare Function ps4000SetTriggerChannelConditions Lib "ps4000.dll" (ByVal handle As Integer, ByRef conditions As TRIGGER_CONDITION, ByVal nConditions As Short) As Integer
    Declare Function ps4000SetTriggerChannelDirections Lib "ps4000.dll" (ByVal handle As Integer, ByVal channelA As Integer, ByVal channelB As Integer, ByVal channelC As Integer, ByVal channelD As Integer, ByVal ext As Integer, ByVal aux As Integer) As Integer
    Declare Function SetTriggerProperties Lib "ps4000wrap.dll" (ByVal handle As Integer, ByRef triggerChannelPropertiesArray As Integer, ByVal nProperties As Integer, ByVal auxEnable As Integer, ByVal autoTrig As Integer) As Integer

    Declare Function RunBlock Lib "ps4000wrap.dll" (ByVal handle As Integer, ByVal noPreTriggerSamples As Integer, ByVal noPostTriggerSamples As Integer, ByVal timebase As Integer, ByVal oversample As Integer, ByVal segmentIndex As Integer) As Integer
    Declare Function GetStreamingLatestValues Lib "ps4000wrap.dll" (ByVal handle As Integer) As Integer
    Declare Function AvailableData Lib "ps4000wrap.dll" (ByVal handle As Integer) As Integer
    Declare Function AutoStopped Lib "ps4000wrap.dll" (ByVal handle As Integer) As Integer
    Declare Function IsReady Lib "ps4000wrap.dll" (ByVal handle As Integer) As Integer

    Declare Sub Sleep Lib "kernel32.dll" (ByVal time As Integer)

    Dim handle As Integer
    Dim status As Integer
    Dim S As String = "No_Info"


    Sub Main()

        Dim overflow As Integer
        Dim max_samples As Integer
        Dim time_interval As Integer
        Dim required As Integer
        Dim timebase As Integer
        Dim triggerChannelPropertiesArray(0 To 5) As Integer
        Dim j As Integer
        Dim no_of_samples

        status = ps4000OpenUnit(handle)

        If handle = 0 Then
            MsgBox("Unit not opened", vbOKOnly, "Error Message")
            Exit Sub
        End If

        For i = 0 To 5 Step 1
            j = ps4000GetUnitInfo(handle, S, 255, required, i)
            Console.WriteLine(S)
        Next i

        Call ps4000SetChannel(handle, 0, 1, 0, 10)
        Call ps4000SetChannel(handle, 1, 1, 0, 10)

        Console.WriteLine("PS4000 opened")

        'find the maximum number of samples, the time interval (in time_units),
        'the most suitable time units, and the maximum oversample at the current timebase

        timebase = 21       'Depends on scope model
        no_of_samples = 5000

        ' ReDim values_a(no_of_samples) As Integer
        ' ReDim values_b(no_of_samples) As Integer
        Dim Values_a(5000) As Short
        Dim Values_b(5000) As Short
        Dim Value As Integer


        status = ps4000GetTimebase(handle, timebase, no_of_samples, time_interval, 1, max_samples, 0)

        Call ps4000SetDataBuffer(handle, 0, values_a(0), no_of_samples)
        Call ps4000SetDataBuffer(handle, 1, values_b(0), no_of_samples)


        'Set up the trigger structures

        Dim triggerConditions As TRIGGER_CONDITION

        triggerConditions.channelA = 1
        triggerConditions.channelB = 0
        triggerConditions.channelC = 0
        triggerConditions.channelD = 0
        triggerConditions.external = 0
        triggerConditions.aux = 0
        triggerConditions.pulseWidthQualifier = 0


        triggerChannelPropertiesArray(0) = 0         'thresholdUpper
        triggerChannelPropertiesArray(1) = 1000      'thresholdUpperHysteresis;
        triggerChannelPropertiesArray(2) = 0         'thresholdLower
        triggerChannelPropertiesArray(3) = 1000      'thresholdUpperHysteresis;
        triggerChannelPropertiesArray(4) = 0         'channel
        triggerChannelPropertiesArray(5) = 0         'thresholdMode

        'Set trigger
        Call ps4000SetTriggerChannelConditions(handle, triggerConditions, 0)
        Call ps4000SetTriggerChannelDirections(handle, 2, 2, 0, 0, 0, 0)
        Call SetTriggerProperties(handle, triggerChannelPropertiesArray(0), 1, 1, 1000)

        Dim Ready As Short
        Ready = 3

        status = RunBlock(handle, 0, no_of_samples, timebase, 0, 0)

        Ready = IsReady(handle) = 0

        While Ready
            Sleep(0)
        End While

        Sleep(1000)
        Call ps4000Stop(handle)

        ' once the ready flag is set, the data has been captured and is ready for download using get values
        status = ps4000GetValues(handle, 0, no_of_samples, 1, 0, 0, 0)

        For i = 0 To (no_of_samples - 1)
            Value = time_interval * i
            Console.WriteLine(Value)
            Value = Values_a(i)
            Console.WriteLine(Value)
            Value = (Values_a(i) / 32767) * 20000
            Console.WriteLine(Value)
            Value = Values_b(i)
            Console.WriteLine(Value)
            Value = (Values_b(i) / 32767) * 20000
            Console.WriteLine(Value)

        Next i

        ps4000CloseUnit(handle)

    End Sub
End Module


